# std::strong_ordering

From cppreference.com
< cpp‎ | utility

Defined in header `<compare>` |  |
class strong_ordering; |  | (since C++20)

The class type `std::strong_ordering` is the result type of a three-way comparison that

- admits all six relational operators (==, !=, <, <=, >, >=)

- implies substitutability: if a is equivalent to b, f(a) is also equivalent to f(b), where f denotes a function that reads only comparison-salient state that is accessible via the argument's public const members. In other words, equivalent values are indistinguishable.
- does not allow incomparable values: at least one of a < b, a == b, and a > b must be true

### Constants

The type `std::strong_ordering` has four valid values, implemented as const static data members of its type:

Member constant | Definition
less(inline constexpr) [static] | a valid value of the type `std::strong_ordering` indicating less-than (ordered before) relationship (public static member constant)
equivalent(inline constexpr) [static] | a valid value of the type `std::strong_ordering` indicating equivalence (neither ordered before nor ordered after) (public static member constant)
equal(inline constexpr) [static] | a valid value of the type `std::strong_ordering` indicating equivalence (neither ordered before nor ordered after) (public static member constant)
greater(inline constexpr) [static] | a valid value of the type `std::strong_ordering` indicating greater-than (ordered after) relationship (public static member constant)

### Conversions

`std::strong_ordering` is the strongest of the five comparison categories: it is not implicitly-convertible from any other category and is implicitly-convertible to the other four.

operator strong_equality | implicit conversion to std::strong_equality (public member function)

## std::strong_ordering::operator strong_equality

constexpr operator strong_equality() const noexcept; |  |

### Return value

std::strong_equality::equal if `v` is `equivalent` or `equal`, std::strong_equality::nonequal if `v` is `less` or `greater`.

operator weak_equality | implicit conversion to std::weak_equality (public member function)

## std::strong_ordering::operator weak_equality

constexpr operator weak_equality() const noexcept; |  |

### Return value

std::weak_equality::equivalent if `v` is `equal` or `equivalent`, std::weak_equality::nonequivalent if `v` is `less` or `greater`.

operator partial_ordering | implicit conversion to std::partial_ordering (public member function)

## std::strong_ordering::operator partial_ordering

constexpr operator partial_ordering() const noexcept; |  |

### Return value

std::partial_ordering::less if `v` is `less`, std::partial_ordering::greater if `v` is `greater`, std::partial_ordering::equivalent if `v` is `equal` or `equivalent`.

operator weak_ordering | implicit conversion to std::weak_ordering (public member function)

## std::strong_ordering::operator weak_ordering

constexpr operator weak_ordering() const noexcept; |  |

### Return value

std::weak_ordering::less if `v` is `less`, std::weak_ordering::greater if `v` is `greater`, std::weak_ordering::equivalent if `v` is `equal` or `equivalent`.

### Comparisons

Comparison operators are defined between values of this type and literal ​0​. This supports the expressions a <=> b == 0 or a <=> b < 0 that can be used to convert the result of a three-way comparison operator to a boolean relationship; see `std::is_eq`, `std::is_lt`, etc.

The behavior of a program that attempts to compare a `strong_ordering` with anything other than the integer literal ​0​ is undefined.

operator==operator!=operator<operator>operator<=operator>=operator<=> | compares with zero (function)

## operator==

friend constexpr bool operator==(strong_ordering v, /*unspecified*/ u) noexcept; friend constexpr bool operator==(/*unspecified*/ u, strong_ordering v) noexcept; |  |

### Parameters

v | - | a `std::strong_ordering` value to check
u | - | an unused parameter of any type that accepts literal zero argument

### Return value

true if `v` is `equivalent` or `equal`, false if `v` is `less` or `greater`

## operator!=

friend constexpr bool operator!=(strong_ordering v, /*unspecified*/ u) noexcept; friend constexpr bool operator!=(/*unspecified*/ u, strong_ordering v) noexcept; |  |

### Parameters

v | - | a `std::strong_ordering` value to check
u | - | an unused parameter of any type that accepts literal zero argument

### Return value

true if `v` is `less` or `greater`, and false if `v` is `equivalent` or `equal`

## operator<

friend constexpr bool operator<(strong_ordering v, /*unspecified*/ u) noexcept; | (1) |
friend constexpr bool operator<(/*unspecified*/ u, strong_ordering v) noexcept; | (2) |

### Parameters

v | - | a `std::strong_ordering` value to check
u | - | an unused parameter of any type that accepts literal zero argument

### Return value

1) true if `v` is `less`, and false if `v` is `greater`, `equivalent`, or `equal`
2) true if `v` is `greater`, and false if `v` is `less`, `equivalent`, or `equal`

## operator<=

friend constexpr bool operator<=(strong_ordering v, /*unspecified*/ u) noexcept; | (1) |
friend constexpr bool operator<=(/*unspecified*/ u, strong_ordering v) noexcept; | (2) |

### Parameters

v | - | a `std::strong_ordering` value to check
u | - | an unused parameter of any type that accepts literal zero argument

### Return value

1) true if `v` is `less`, `equivalent`, or `equal`, and false if `v` is `greater`
2) true if `v` is `greater`, `equivalent`, or `equal`, and false if `v` is `less`

## operator>

friend constexpr bool operator>(strong_ordering v, /*unspecified*/ u) noexcept; | (1) |
friend constexpr bool operator>(/*unspecified*/ u, strong_ordering v) noexcept; | (2) |

### Parameters

v | - | a `std::strong_ordering` value to check
u | - | an unused parameter of any type that accepts literal zero argument

### Return value

1) true if `v` is `greater`, and false if `v` is `less`, `equivalent`, or `equal`
2) true if `v` is `less`, and false if `v` is `greater`, `equivalent`, or `equal`

## operator>=

friend constexpr bool operator>=(strong_ordering v, /*unspecified*/ u) noexcept; | (1) |
friend constexpr bool operator>=(/*unspecified*/ u, strong_ordering v) noexcept; | (2) |

### Parameters

v | - | a `std::strong_ordering` value to check
u | - | an unused parameter of any type that accepts literal zero argument

### Return value

1) true if `v` is `greater`, `equivalent`, or `equal`, and false if `v` is `less`
2) true if `v` is `less`, `equivalent`, or `equal`, and false if `v` is `greater`

## operator<=>

friend constexpr strong_ordering operator<=>(strong_ordering v, /*unspecified*/ u) noexcept; | (1) |
friend constexpr strong_ordering operator<=>(/*unspecified*/ u, strong_ordering v) noexcept; | (2) |

### Parameters

v | - | a `std::strong_ordering` value to check
u | - | an unused parameter of any type that accepts literal zero argument

### Return value

1) v.
2) `greater` if `v` is `less`, `less` if `v` is `greater`, otherwise `v`.

### Example

| This section is incomplete Reason: no example

### See also

weak_ordering (C++20) | the result type of 3-way comparison that supports all 6 operators and is not substitutable (class)
partial_ordering (C++20) | the result type of 3-way comparison that supports all 6 operators, is not substitutable, and allows incomparable values (class)
strong_equality (C++20) | the result type of 3-way comparison that supports only equality/inequality and is substitutable (class)
weak_equality (C++20) | the result type of 3-way comparison that supports only equality/inequality and is not substitutable (class)

Retrieved from "https://en.cppreference.com/mwiki/index.php?title=cpp/utility/compare/strong_ordering&oldid=109485"